/*
 * Simulator of MCS51 (itsrccl.h)
 *
 * Copyright (C) 1997,97 Drotos Daniel, Talker Bt.
 * 
 * To contact author send email to drdani@mazsola.iit.uni-miskolc.hu
 *
 */

/* This file is part of MCS51 simulator: s51.

S51 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

S51 is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with S51; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA. */
/*@1@*/

#ifndef ITSRCCL_HEADER
#define ITSRCCL_HEADER

#include "pobjcl.h"
#include "stypes.h"


class cl_it_src: public cl_base
{
public:
  uchar ie_mask;  // Mask in IE register
  uchar src_reg;  // Register in SFR of source
  uchar src_mask; // Mask of source bit in src_reg
  uint  addr;     // Address of service routine
  bool  clr_bit;  // Request bit must be cleared when IT accepted
  char  *name;	  // For debug
  bool  active;   // Acceptance can be disabled

  cl_it_src(uchar Iie_mask,
	    uchar Isrc_reg,
	    uchar Isrc_mask,
	    uint  Iaddr,
	    bool  Iclr_bit,
	    char  *Iname);
  virtual ~cl_it_src(void);

          bool is_active(void);
  virtual void set_active_status(bool Aactive);
  virtual void activate(void);
  virtual void deactivate(void);
};


#endif

/* End of itsrccl.h */
